package cn.estsh.i3plus.pojo.base.enumutil;

import com.fasterxml.jackson.annotation.JsonFormat;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @Date : 2018-10-23 16:10
 * @Modify :
 **/
public class ImppEnumUtil {

    /**
     * 组织类型
     * 1.集团，2.公司，3.工厂
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum ORGANIZE_YTPE{

        TYPE_GROUP(1,"集团","组织类型为集团"),
        TYPE_COMPANY(2,"公司","组织类型为公司"),
        TYPE_FACTORY(3,"工厂","组织类型为集团"),
        ;

        private int value;
        private String name;
        private String description;

        ORGANIZE_YTPE() {
        }

        ORGANIZE_YTPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 定时任务方法类型
     * 1.Java Class 方法
     * 2.Http URL
     * 3.权限CODE
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TASK_METHOD_TYPE{
        TYPE_GROUP(1,"类方法","Java Class 方法");
//        TYPE_COMPANY(2,"链接","Http URL"),
//        TYPE_FACTORY(3,"权限CODE","权限CODE");

        private int value;
        private String name;
        private String description;

        TASK_METHOD_TYPE() {
        }

        TASK_METHOD_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     *  日志级别
     * 1.DEBUG：调试程序信息，
     * 2.INFO：程序运行信息，
     * 3.WARN：具有潜在危害的信息，
     * 4.ERROR：错误信息但允许程序继续运行，
     * 5.FATAL：非常严重的错误，可能导致程序中止
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum LOG_LEVEL{

        DEBUG(1,"DEBUG","调试程序信息"),
        INFO(2,"INFO","程序运行信息"),
        WARN(3,"WARN","具有潜在危害的信息"),
        ERROR(4,"ERROR","错误信息但允许程序继续运行"),
        FATAL(5,"FATAL","非常严重的错误，可能导致程序中止");

        private int value;
        private String name;
        private String description;

        LOG_LEVEL() {
        }

        LOG_LEVEL(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 操作日志类型
     * 1.INSERT：添加，
     * 2.DELETE：删除，
     * 3.UPDATE：修改，
     * 4.SELECT：查询
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OPERATE_TYPE{

        INSERT(1,"post","新增"),    //POST
        DELETE(2,"put","修改"),    //PUT
        UPDATE(3,"delete","删除"),    //DELETE
        SELECT(4,"get","查询"),    //GET
        BUSI(5,"busi","处理");

        private int value;
        private String name;
        private String description;

        OPERATE_TYPE() {
        }

        OPERATE_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static int codeOfValue(String code) {
            int tmp = 1;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].value;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 操作终端
     * 1.PC：个人计算机
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum OPERATE_TERMINAL{

        PC(1,"电脑端"),PDA(2,"PDA"),MOBILE(3,"手机");

        private int value;
        private String description;

        OPERATE_TERMINAL() {
        }

        OPERATE_TERMINAL(int value, String description) {
            this.value = value;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

    }

    /**
     * 用户消息状态
     * 1.READ：已读
     * 2.UNREAD：未读
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MESSAGE_STATUS {

        READ(1,"已读","fa cell-fa fa-file-text"),
        UNREAD(2,"未读","fa cell-fa fa-file-o");

        private int value;
        private String name;
        private String description;

        MESSAGE_STATUS() {
        }

        MESSAGE_STATUS(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 用户消息类型
     * 1.NOTICE：通知
     * 2.STATION_LETTER：站内信
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MESSAGE_TYPE {

        MAIL(1,"邮件","邮件"),
        LETTER(2,"站内信","站内信");

        private int value;
        private String name;
        private String description;

        MESSAGE_TYPE() {
        }

        MESSAGE_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 硬件连接方式
     * 1.SERIAL_PORT：通知
     * 2.NETWORK_PORT：站内信
     * 3.OPC：OPC
     * 4.USB：USB
     * 5.MIDDLE_TABLE：中间表
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TOOL_CONN_TYPE{

        SERIAL_PORT(1,"串口","串口"),
        NETWORK_PORT(2,"网口","网口"),
        OPC(3,"OPC","OPC"),
        USB(4,"USB","USB"),
        MIDDLE_TABLE(5,"中间表","中间表");
        private int value;
        private String name;
        private String description;

        TOOL_CONN_TYPE() {
        }

        TOOL_CONN_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 硬件数据类型
     * 1.STRING：字符串
     * 2.TABLE：数据表
     * 3.BINARY_PACKET：二进制数据包
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum TOOL_DATA_TYPE{

        STRING(1,"字符串","字符串"),
        TABLE(2,"数据表","数据表"),
        BINARY_PACKET(3,"二进制数据包","二进制数据包");

        private int value;
        private String name;
        private String description;

        TOOL_DATA_TYPE() {
        }

        TOOL_DATA_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 系统参数类型
     * 1.SYSTEM：系统参数
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum SYS_CONFIG_TYPE{

        SYSTEM(1,"系统参数","系统参数");

        private int value;
        private String name;
        private String description;

        SYS_CONFIG_TYPE() {
        }

        SYS_CONFIG_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }

    /**
     * 消息内容类型
     * 1.SYSTEM：系统参数
     */
    @JsonFormat(shape = JsonFormat.Shape.OBJECT)
    public enum MESSAGE_CONTENT_TYPE{

        HTML(1,"HTML","text/plain;charset=UTF-8"),
        TEXT(2,"TEXT","text/plain;charset=UTF-8");

        private int value;
        private String name;
        private String description;

        MESSAGE_CONTENT_TYPE() {
        }

        MESSAGE_CONTENT_TYPE(int value, String name, String description) {
            this.value = value;
            this.name = name;
            this.description = description;
        }

        public int getValue() {
            return value;
        }

        public String getName() {
            return name;
        }

        public String getDescription() {
            return description;
        }

        public static String valueOfCode(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].name;
                }
            }
            return tmp;
        }

        public static String valueOfDescription(int val) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].value == val) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }

        public static String codeOfDescription(String code) {
            String tmp = null;
            for (int i = 0; i < values().length; i++) {
                if (values()[i].name.equals(code)) {
                    tmp = values()[i].description;
                }
            }
            return tmp;
        }
    }
}
